# -*- coding: utf-8 -*-
"""
Created on Sat Jul  8 12:35:56 2023

@author: Pablo
"""
import matplotlib.pyplot as plt
import numpy as np
from scipy.signal import chirp, find_peaks, peak_widths
import seaborn as sns
h = 4.1357E-15 #eVs
c = 299792458E9 #nm/s

def Extract(lst):
    return [item[0] for item in lst]


def findmax (array,noise):
    #(array)
    #print(array)
    #print(array.size)
    index = np.argwhere(array[:] == np.max(array) )[0][0]
    print(index)
    print(array[index])
    if array[index] < noise:
        return 0
    else:
        return index

with open('../experimental/plmap_WS2WSe2_50x50_R1_60uW_g150lmm_100um_1s_e473nm_3h.asc') as spectradat:
#with open('../experimental/plmap_WS2_WSe2_E532_450uW_01s_4h.asc') as spectradat:
#with open('../experimental/plmap_WS2_WSe2_E532_400uW_01s_6h.asc') as spectradat:
    #spectradat = spectradat.read()
    linea = []
    lines = []
    count = 0
    while True:
        spectra = spectradat.readline()
        
        if len(spectra) == 0:
         break
        elementos = ""
        for element in spectra:
            if element == "\t" :
                linea.append(float(elementos))
                elementos =""
                continue
            if element == ",":
                #print ("here")
                element = "."
                lines.append(linea)
                #print(linea)
                linea = []
            elementos += element
        
            
lines = lines[1:]
espectro = np.zeros((len(lines),51,51))
i=0
for item in lines:
    
    items = item[1:]
    j=0
    switch = 1
    for y in range(0,51,1):
        if switch == 1:
            for x in range(0,51,1):
                #print(x,y)
                espectro[i,x,y] = items [j]
                #print (j)
                j+=1
        else:
                for x in range(50,-1,-1):
                    #print(x,y)
                    espectro[i,x,y] = items [j]
                    #print (j)
                    j+=1
        switch = -1 * switch
    i+=1
energies = np.zeros(len(lines))
energies[:] = Extract(lines)
energies[:] = h*c/energies[:]

minindex = np.argwhere(1.62 < energies[:])[-1][0]
maxindex = np.argwhere (1.67 > energies[:])[0][0]
emax= np.zeros((51,51))
peaks = []
for y in range(0,51):
    for x in range(0,51,1):
       print(x,y)
       #print(espectro[maxindex:minindex,x,y])
       value = findmax(espectro[maxindex:minindex,x,y],400)
       #print(value)
       if value == 0:
           emax[x,y] = np.nan
       else:
           emax[x,y] =energies[value+ maxindex]
           #print(emax[x,y])
fig, ax = plt.subplots()
print (np.nanmin(emax))
print (np.nanmax(emax))

plt.imshow(emax, cmap='viridis',vmin =np.nanmin(emax),vmax = np.nanmax(emax))
plt.colorbar()
plt.xlabel("Distancia ($\mu m$)")
plt.ylabel("Distancia ($\mu m$)")

plt.title("Energías máximas del pico de 1.65eV en el mapeo. 3h recocido")
plt.legend()